Index: src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_atomcount.hpp
===================================================================
--- src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_atomcount.hpp	(revision 24eb6b9e8f3b4ff8f95f2e26c0a57c2296d904de)
+++ src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_atomcount.hpp	(revision b6587939d0431dec255b436d437b2c3d64d32c2c)
@@ -27,17 +27,17 @@
 
   QtMoleculeItem_atomcount(
-      QtObservedMolecule::ptr &_ObservedMolecule) :
-        QtMoleculeItem(_ObservedMolecule)
+      QtObservedMolecule::ptr &_ObservedMolecule)
   {
     // cannot call pure virtual function in QtMoleculeItem's cstor
-    internal_updateState();
+    updateState(_ObservedMolecule);
   }
 
   /** Performs the update of the molecule's atomcount.
    *
+   * \param _ObservedMolecule object to update state from
    */
-  void internal_updateState()
+  void updateState(const QtObservedMolecule::ptr &_ObservedMolecule)
   {
-    setText(QString::number(ObservedMolecule->getAtomCount()));
+    setText(QString::number(_ObservedMolecule->getAtomCount()));
   }
 
Index: src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_formula.hpp
===================================================================
--- src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_formula.hpp	(revision 24eb6b9e8f3b4ff8f95f2e26c0a57c2296d904de)
+++ src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_formula.hpp	(revision b6587939d0431dec255b436d437b2c3d64d32c2c)
@@ -29,17 +29,17 @@
 
   QtMoleculeItem_formula(
-      QtObservedMolecule::ptr &_ObservedMolecule) :
-        QtMoleculeItem(_ObservedMolecule)
+      QtObservedMolecule::ptr &_ObservedMolecule)
   {
     // cannot call pure virtual function in QtMoleculeItem's cstor
-    internal_updateState();
+    updateState(_ObservedMolecule);
   }
 
   /** Performs the update of the molecule's formula.
    *
+   * \param _ObservedMolecule object to update state from
    */
-  void internal_updateState()
+  void updateState(const QtObservedMolecule::ptr &_ObservedMolecule)
   {
-    setText(QString(ObservedMolecule->getMolFormula().c_str()));
+    setText(QString(_ObservedMolecule->getMolFormula().c_str()));
   }
 
Index: src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_name.hpp
===================================================================
--- src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_name.hpp	(revision 24eb6b9e8f3b4ff8f95f2e26c0a57c2296d904de)
+++ src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_name.hpp	(revision b6587939d0431dec255b436d437b2c3d64d32c2c)
@@ -28,20 +28,31 @@
   QtMoleculeItem_name(
       QtObservedMolecule::ptr &_ObservedMolecule) :
-        QtMoleculeItem(_ObservedMolecule)
+        id(_ObservedMolecule->getMolIndex())
   {
     // cannot call pure virtual function in QtMoleculeItem's cstor
-    internal_updateState();
+    updateState(_ObservedMolecule);
   }
 
   /** Performs the update of the molecule's name.
    *
+   * \param _ObservedMolecule object to update state from
    */
-  void internal_updateState()
+  void updateState(const QtObservedMolecule::ptr &_ObservedMolecule)
   {
-    setText(QString(ObservedMolecule->getMolName().c_str()));
+    setText(QString(_ObservedMolecule->getMolName().c_str()));
   }
 
   QtMoleculeItem::COLUMNTYPES getType() const
   { return QtMoleculeItem::NAME; }
+
+  /** Getter for the id of the observed molecule for this item.
+   *
+   * \return id of the observed molecule
+   */
+  const moleculeId_t getMoleculeId() const
+  { return id; }
+
+private:
+  const moleculeId_t id;
 };
 
Index: src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_occurrence.hpp
===================================================================
--- src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_occurrence.hpp	(revision 24eb6b9e8f3b4ff8f95f2e26c0a57c2296d904de)
+++ src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_occurrence.hpp	(revision b6587939d0431dec255b436d437b2c3d64d32c2c)
@@ -27,15 +27,15 @@
 
   QtMoleculeItem_occurrence(
-      QtObservedMolecule::ptr &_ObservedMolecule) :
-        QtMoleculeItem(_ObservedMolecule)
+      QtObservedMolecule::ptr &_ObservedMolecule)
   {
     // cannot call pure virtual function in QtMoleculeItem's cstor
-    internal_updateState();
+    updateState(_ObservedMolecule);
   }
 
   /** Performs the update of the molecule's occurrence.
    *
+   * \param _ObservedMolecule object to update state from
    */
-  void internal_updateState()
+  void updateState(const QtObservedMolecule::ptr &_ObservedMolecule)
   {
     setText(QString(""));
Index: src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_visibility.hpp
===================================================================
--- src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_visibility.hpp	(revision 24eb6b9e8f3b4ff8f95f2e26c0a57c2296d904de)
+++ src/UIElements/Views/Qt4/MoleculeList/SpecificItems/QtMoleculeItem_visibility.hpp	(revision b6587939d0431dec255b436d437b2c3d64d32c2c)
@@ -28,20 +28,31 @@
   QtMoleculeItem_visibility(
       QtObservedMolecule::ptr &_ObservedMolecule) :
-        QtMoleculeItem(_ObservedMolecule)
+        id(_ObservedMolecule->getMolIndex())
   {
     setFlags(flags() | Qt::ItemIsUserCheckable);
     setCheckState(Qt::Unchecked);
     // cannot call pure virtual function in QtMoleculeItem's cstor
-    internal_updateState();
+    updateState(_ObservedMolecule);
   }
 
   /** Performs the update of the molecule's visibility.
    *
+   * \param _ObservedMolecule object to update state from
    */
-  void internal_updateState()
+  void updateState(const QtObservedMolecule::ptr &_ObservedMolecule)
   {}
 
   QtMoleculeItem::COLUMNTYPES getType() const
   { return QtMoleculeItem::VISIBILITY; }
+
+  /** Getter for the id of the observed molecule for this item.
+   *
+   * \return id of the observed molecule
+   */
+  const moleculeId_t getMoleculeId() const
+  { return id; }
+
+private:
+  const moleculeId_t id;
 };
 
